#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct
{
} t_base;

typedef struct
{
  int content;
} t_integer;

typedef struct
{
  char *content;
} t_string;

typedef union
{
  t_base base;
  t_integer integer;
  t_string string;
} t_object;

void print_object (t_object *this)
{
  printf ("Wenn dies eine Integer ist, dann lautet sie: %d.\n", this->integer.content);
  printf ("Wenn dies ein String ist, ist er %zu Zeichen lang.\n",
          strlen (this->string.content));
}

t_object *new_integer (int i)
{
  t_object *p = malloc (sizeof (t_integer));
  p->integer.content = i;
  return p;
}

t_object *new_string (char *s)
{
  t_object *p = malloc (sizeof (t_string));
  p->string.content = s;
  return p;
}

int main (void)
{
  t_object *object[] = { new_integer (42),
                         new_string ("Hello, world!"),
                         NULL };

  for (int i = 0; object[i]; i++)
    print_object (object[i]);

  for (int i = 0; object[i]; i++)
    free (object[i]);

  return 0;
}
