#include <stdio.h>
#include <stdint.h>

void print_hex (uint32_t x)
{
  char digit[8];
  int i = 0;
  while (x)
    {
      digit[i] = x & 0x0000000f;
      x >>= 4;
      i++;
    }
  while (i > 0)
    {
      i--;
      if (digit[i] < 10)
        printf ("%d", digit[i]);
      else
        printf ("%c", 'a' + digit[i] - 10);
    }
}

int main (void)
{
  print_hex (0xcafe42);
  printf ("\n");
  return 0;
}
