#include <stdio.h>

float f (float x)
{
  return x * x * x;
}

float df_a (float x)
{
  return 3.0 * x * x;
}

float df_n (float x)
{
  float dx = 0.1;
  float df = f (x + 0.5 * dx) - f (x - 0.5 * dx);
  return df / dx;
}

int main (void)
{
  for (float x = -3.0; x <= 3.0; x += 0.1)
    printf ("%11f %11f %11f %11f\n", x, f (x), df_a (x), df_n (x));
  return 0;
}
