#include <stdio.h>
#include <string.h>

void insert_into_string (char src, char *target, int pos)
{
  int len = strlen (target);
  for (int i = len; i >= pos; i--)
    target[i + 1] = target[i];
  target[pos] = src;
}

void insert_into_string_sorted (char src, char *target)
{
  int l = 0;
  int r = 0;
  while (target[r])
    r++;
  int m = (l + r) / 2;
  while (m > l)
    {
      if (src < target[m])
        r = m;
      else
        l = m;
      m = (l + r) / 2;
    }
  if (target[m] == 0 || src < target[m])
    insert_into_string (src, target, m);
  else
    insert_into_string (src, target, m + 1);
}

int main (void)
{
  char test[100] = "";
  insert_into_string_sorted ('c', test);
  insert_into_string_sorted ('a', test);
  insert_into_string_sorted ('d', test);
  insert_into_string_sorted ('b', test);
  printf ("test = \"%s\"\n", test);
  for (char ch = 'e'; ch < 'z'; ch += 2)
    insert_into_string_sorted (ch, test);
  insert_into_string_sorted ('n', test);
  printf ("test = \"%s\"\n", test);
  return 0;
}
