#include <stdio.h>
#include <string.h>

void insert_into_string (char src, char *target, int pos) {
  // Bestimme die Länge des Strings target
  int len = strlen(target);

  // Verschiebe alle Zeichen des Strings ab der Stelle pos um eine Stelle nach rechts
  for (int i = len; i > pos; i--) {
    target[i] = target[i-1];
  }

  // Füge das Zeichen src an der Stelle pos ein
  target[pos] = src;
}

void insert_into_string_sorted (char src, char *target) {
  // Bestimme die Länge des Strings target
  int len = strlen(target);

  // Iteriere über alle Zeichen des Strings target
  for (int i = 0; i < len; i++) {  // Wenn das aktuelle Zeichen alphabetisch hinter src liegt, füge src an dieser Stelle ein
    if (target[i] > src) {
      insert_into_string(src, target, i);
      return;
    }
  }

  // Wenn src das letzte Zeichen im String ist, füge es am Ende des Strings ein
  insert_into_string(src, target, len);
}

int main (void)
{
  char test[100] = "";
  insert_into_string_sorted ('c', test);
  insert_into_string_sorted ('a', test);
  insert_into_string_sorted ('d', test);
  insert_into_string_sorted ('b', test);
  printf ("%s\n", test);
  return 0;
}
